# ../addons/eventscripts/superdice/superdice.py
##########################
#~~~~~~~Super~Dice~~~~~~~#
#~~~~~~~~~By~MiB~~~~~~~~~#
##########################

import es
import random
import cmdlib
import popuplib
import gamethread
import weaponlib
import usermsg
import effectlib
import psyco
psyco.full()

# GunGame 5.1
GGon = False
es.dbgmsg(0,"[Super Dice] Trying to import GunGame 5.1....")
try:
        from gungame51.core.players.shortcuts import Player as GGPlayer
        GGon = True
        es.dbgmsg(0,"[Super Dice] Successfully imported GunGame 5.1!")
except ImportError:
        GGon = False
        es.dbgmsg(0,"[Super Dice] Couldn't import GunGame 5.1 disabling GG 5.1 Super Dice functions....")

info = es.AddonInfo()
info["name"] = "Super Dice"
info["basename"] = "superdice"
info["version"] = "0.9.1"
info["authors"] = "MiB"
info["url"] = "http://www.warcraft-source.com"
info["description"] = "The best dice mod!"

def es_map_start(ev):
	es.loadevents(events)
	roundchange(0)
        stoprepeat()
        downloads()

def tickcallback():
        global tick
        tick += 1
        if tick == int(es.ServerVar("superdice_tickrate")):
                tick = 0
                for userid in es.getUseridList():
                        if es.exists("userid",userid):
                                if es.getplayersteamid(userid) != "BOT":
                                        player = Player(userid)
                                        userid = str(userid)
                                        if userid in players:
                                                if not player.getdead():
                                                        if str(players[userid]["beacon"]).isdigit():
                                                                if int(players[userid]["beacon"]) == 1:
                                                                        player.beacon()
                                                        if str(players[userid]["tunnel"]).isdigit():
                                                                if int(players[userid]["tunnel"]) == 1:
                                                                        player.fov(150)
                                                        if str(players[userid]["drug"]).isdigit(): 
                                                                if int(players[userid]["drug"]) == 1:
                                                                        player.overlay(es.ServerVar("superdice_drugoverlay"))
                                                                        player.fov(120)
                                                        if str(players[userid]["deadman"]).isdigit():
                                                                if int(players[userid]["deadman"]) == 1:
                                                                        player.overlay("superdice/deadman.vmt")

class Player():
        def __init__(self,userid):
                self.userid = int(userid)
                self.exists = es.exists("userid",self.userid)
                self.dead = bool(es.getplayerprop(self.userid,"CCSPlayer.baseclass.pl.deadflag"))
                self.team = es.getplayerteam(self.userid)
        def getprop(self,prop):
                return es.createplayerlist(self.userid)[self.userid][prop]
        def getdead(self):
                return self.dead
        def beacon(self):
                if self.team == 3:
                        r = 0
                        b = 255
                else:
                        r = 255
                        b = 0
                x,y,z = es.getplayerlocation(self.userid)
                effectlib.drawCircle((x,y,z + 30),radius=100,steps=12,halo=es.ServerVar("superdice_beaconmodel"),model=es.ServerVar("superdice_beaconmodel"),seconds=0.1,width=20,endwidth=20,red=r,green=50,blue=b)
                effectlib.drawLine((x,y,z + 99999),(x,y,z),halo=es.ServerVar("superdice_beaconmodel"),model=es.ServerVar("superdice_beaconmodel"),seconds=0.1,width=20,endwidth=20,red=r,green=50,blue=b)
        def fov(self,fov):
                es.setplayerprop(self.userid,"CCSPlayer.baseclass.m_iFOV",fov)
        def overlay(self,overlay):
                es.cexec(self.userid,"r_screenoverlay %s"%overlay)
        def renderfx(self,fx):
                es.fire(self.userid,"!self","addoutput","renderfx %s"%fx)
        def damage(self,victim,damage):
                if not Player(victim).getdead():
                        health = es.getplayerprop(victim,"CBasePlayer.m_iHealth")
                        if damage < health:
                                health -= damage
                                es.setplayerprop(victim,"CBasePlayer.m_iHealth",health)
                        else:
                                entity = es.createentity("point_hurt")
                                es.entitysetvalue(entity,"targetname","sd_damage")
                                es.entitysetvalue(entity,"damage",damage)
                                es.entitysetvalue(entity,"damagetype",32)
                                es.entitysetvalue(entity,"damagetarget","sd_target")
                                es.entitysetvalue(entity,"classname",Player(self.userid).getprop("weapon"))
                                es.fire(victim,"!self","addoutput","targetname sd_target")
                                es.fire(self.userid,"sd_damage","hurt")
                                es.fire(self.userid,"sd_damage","kill")
                                es.fire(victim,"!self","addoutput","targetname sd_player")
        def respawn(self):
                if self.dead:
                        es.setplayerprop(self.userid,"CCSPlayer.m_iPlayerState",0)
                        es.setplayerprop(self.userid,"CCSPlayer.baseclass.m_lifeState",512)
                es.server.queuecmd("es_xspawnplayer %s"%self.userid)
        def teleport(self,xyz):
                xyz[2] = float(xyz[2]) - 50.0
                es.setpos(self.userid,xyz[0],xyz[1],xyz[2])

def downloads():
        es.stringtable("downloadables","sound/%s"%es.ServerVar("superdice_rollsound"))
        es.stringtable("downloadables","sound/%s"%es.ServerVar("superdice_menusound"))
        es.stringtable("downloadables","sound/%s"%es.ServerVar("superdice_rollfailsound"))
        es.stringtable("downloadables","materials/superdice/deadman.vmt")
        es.stringtable("downloadables","materials/superdice/deadman.vtf")

def popup_create():
        global superdice_help
        superdice_help = popuplib.easymenu("superdice_help",None,superdice_help)
        superdice_help.settitle("SuperDice Help Menu")
        for block in blocks: superdice_help.addoption(block,"%s - %s"%(blocks[block]["name"],blocks[block]["desc"]))

def check_player(userid):
        userid = str(userid)
        if userid not in players:
                players[userid] = {}
                for var in playervars: players[userid][var] = 0

def superdice_help(userid,choice,popupname):
        es.playsound(userid,es.ServerVar("superdice_menusound"),1.0)
        es.tell(userid,"#multi","\x05%s: %s"%(blocks[choice]["name"],blocks[choice]["desc"]))
        superdice_help.send(userid)

def stoprepeat():
        gamethread.cancelDelayed("blind")
	gamethread.cancelDelayed("roundstart")

def roundchange(change):
        global roundend
        roundend = change

def GGLevelUp(args):
        if len(args) == 2:
                if es.exists("userid",args[0]):
                        GGPlayer(args[0]).levelup(args[1],victim=0,reason="Super Dice Roll Level Up")
                else: es.dbgmsg(0,"*gungame_level_up* The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"*gungame_level_up* You supplied more or less than two arguments.")

def AddBlock(args):
	if len(args) == 3:
		if args[0] not in blocks:
			blocks[args[0]] = {}
			blocks[args[0]]["name"] = args[1]
                        blocks[args[0]]["desc"] = args[2]
                        es.dbgmsg(0,"<addblock> Block was added. <%s - %s - %s>"%(args[0],args[1],args[2]))
		else: es.dbgmsg(0,"<addblock> You supplied a name thats already added. <%s>"%block)
	else: es.dbgmsg(0,"<addblock> You supplied more or less than three arguments.")

def RemoveBlock(args):
	if len(args) == 1:
		if args[0] in blocks:
			del blocks[args[0]]
			es.dbgmsg(0,"<removeblock> Block was removed. <%s>"%args[0])
		else: es.dbgmsg(0,"<removeblock> You supplied a name thats not added. <%s>"%block)
	else: es.dbgmsg(0,"<removeblock> You supplied more or less than one argument.")

def ClearBlocks(args):
	if len(blocks) > 0:
		blocks = {}
	else: es.dbgmsg(0,"<clearblocks> The blocks list is empty.")

def ReloadBlocks(args):
	es.reload("superdice/superdiceblocks")
	es.dbgmsg(0,"<reloadblocks> Blocks reloaded.")

def ReloadConfig(args):
        es.mexec(config)
	es.dbgmsg(0,"<reloadconfig> Config reloaded.")

def CreateHelp(args):
        popup_create()
        es.dbgmsg(0,"<createhelp> Help Menu created.")

def PlayerData(args):
        if len(args) == 4:
                if es.exists("userid",args[1]):
                        userid = str(args[1])
                        if userid not in players: check_player(userid)
                        if args[0] == "set":
                                players[userid][args[2]] = args[3]
                        elif args[0] == "get":
                                if args[2] in players[userid]: es.ServerVar(args[3]).set(players[userid][args[2]])
                                else: es.dbgmsg(0,"<playerdata> Sorry, but it seems that the dataname you supplied does not exist, so can not get your requested data.")
                        elif args[0] == "check":
                                if args[2] in players[userid]: es.ServerVar(args[3]).set(1)
                                else: es.ServerVar(args[3]).set(0)
                        else: es.dbgmsg(0,"<playerdata> Argument one is not set,get, or check, please check your coding.")
                else: es.dbgmsg(0,"<playerdata> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<playerdata> You supplied more or less than four arguments.")

def RandomBlind(args):
        if len(args) == 4:
                if es.exists("userid",args[0]):
                        if es.getplayerprop(args[0],"CCSPlayer.baseclass.pl.deadflag") == 0:
                                __randomblind(args[0],int(args[1]),int(args[2]),float(args[3]))
                        else: es.dbgmsg(0,"<randomblind> The userid you supplied is dead.")
                else: es.dbgmsg(0,"<randomblind> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<randomblind> You supplied more or less than 4 arguments.")

def __randomblind(userid,rbmin,rbmax,rbtime):
        if es.exists("userid",userid):
                if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                        usermsg.fade(userid,2,(rbtime * float(100)),(rbtime * float(100)),0,0,0,255)
                        delay = random.randint(rbmin,rbmax)
                        gamethread.delayedname(delay,"blind",__randomblind,(userid,rbmin,rbmax,rbtime))

def Respawn(args):
        if len(args) == 1:
                if es.exists("userid",args[0]):
                        player = Player(args[0])
                        if player.getdead():
                                player.respawn()
                        else: es.dbgmsg(0,"<respawn> The userid you supplied is alive.")
                else: es.dbgmsg(0,"<respawn> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<respawn> You supplied more or less than one argument.")

def Teleport(args):
        if len(args) == 2:
                if es.exists("userid",args[0]):
                        player = Player(args[0])
                        if not player.getdead():
                                player.teleport(args[1].split(","))
                        else: es.dbgmsg(0,"<teleport> The userid you supplied is dead.")
                else: es.dbgmsg(0,"<teleport> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<teleport> You supplied more or less than two arguments.")

def Damage(args):
        if len(args) == 3:
                if es.exists("userid",args[0]) and es.exists("userid",args[1]):
                        player = Player(args[0])
                        target = Player(args[1])
                        if not target.getdead():
                                player.damage(args[1],int(args[2]))
                        else: es.dbgmsg(0,"<damage> The victim you supplied is dead.")
                else: es.dbgmsg(0,"<damage> The attacker or victim you supplied is not on the server.")
        else: es.dbgmsg(0,"<damage> You supplied more or less than 3 arguments.")

def RenderFX(args):
        if len(args) == 2:
                if es.exists("userid",args[0]):
                        player = Player(args[0])
                        if not player.getdead():
                                player.renderfx(args[1])
                        else: es.dbgmsg(0,"<renderfx> The userid you supplied is dead.")
                else: es.dbgmsg(0,"<renderfx> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<renderfx> You supplied more or less than 2 arguments.")

def chatcommands(userid,text,teamonly):
        if int(userid) < 2: return (userid,text,teamonly)
        else: userid = str(userid)
        text2 = text.strip('"')
        text2 = text2.lower()
	if text2 in ccommands:
                check_player(userid)
		if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0 and roundend == 1 and int(players[userid]["roll"]) == 0:
                        rollchance = random.randint(1,100)
                        if int(es.ServerVar("superdice_rollchance")) < rollchance:
                                roll = random.choice(blocks.keys())
                                if roll in blocks:
                                        rollname = blocks[roll]["name"]
                                        es.event("initialize","superdice_roll")
                                        es.event("setint","superdice_roll","userid",userid)
                                        es.event("setstring","superdice_roll","block",roll)
                                        es.event("setstring","superdice_roll","roll",rollname)
                                        es.event("fire","superdice_roll")
                                        players[userid]["roll"] = 1
                                        if int(es.ServerVar("superdice_shout")) == 1: es.msg("#multi","\x05%s rolled %s."%(es.getplayername(userid),rollname))
                                        else: es.tell(userid,"#multi","\x05You rolled %s."%rollname)
                                        if int(es.ServerVar("superdice_rollinfo")) == 1: usermsg.hudhint(userid,"%s"%blocks[roll]["desc"])
                                else: es.tell(userid,"#multi","\x05Sorry, but theres been a error please roll again.")
                        else:
                                if int(es.ServerVar("superdice_rollchanceshout")) == 1: es.msg("#multi","\x05%s failed to roll anything."%es.getplayername(userid))
                                else: es.tell(userid,"#multi","\x05Sorry, you failed to roll anything.")
                                es.playsound(userid,es.ServerVar("superdice_rollfailsound"),1.0)
                                players[userid]["roll"] = 1
		else: es.tell(userid,"#multi","\x05You cannot roll right now.")
		if int(es.ServerVar("superdice_superdiceblock")) == 1: return (False,False,False)
        elif text2 in hcommands:
                superdice_help.send(userid)
                if int(es.ServerVar("superdice_superdicehelpblock")) == 1: return (False,False,False)
        return (int(userid),text,teamonly)

def round_end(ev):
	roundchange(0)
	stoprepeat()

def round_start(ev):
	gamethread.delayedname(float(es.ServerVar("superdice_rolltime")),"roundstart",roundchange,1)

def player_spawn(ev):
        if ev["es_steamid"] == "BOT": return
        check_player(ev["userid"])
        if int(players[ev["userid"]]["roll"]) == 1: players[ev["userid"]]["roll"] = 0

def superdice_roll(ev):
        es.doblock("superdice/superdiceblocks/%s"%ev["block"])
        es.playsound(ev["userid"],es.ServerVar("superdice_rollsound"),1.0)

def item_pickup(ev):
        if ev["userid"] not in players or ev["es_steamid"] == "BOT": return
        if str(players[ev["userid"]]["berserker"]).isdigit():
                if int(players[ev["userid"]]["berserker"]) == 1 and ev["item"] not in blist:
                        weapon = weaponlib.getWeapon(ev["item"])
                        if weapon is None: return
                        for index in weapon.indexlist:
                                if es.getindexprop(index,"CBaseEntity.m_hOwnerEntity") == es.getplayerhandle(ev["userid"]):
                                        es.remove(index)
                                        es.centertell(ev["userid"],"berserker restrict weapon %s is restricted"%ev["item"])
                                        break

def bullet_impact(ev):
        if ev["userid"] not in players or ev["es_userweapon"] == "weapon_knife" or ev["es_steamid"] == "BOT": return
        if str(players[ev["userid"]]["lasers"]).isdigit():
                if int(players[ev["userid"]]["lasers"]) == 1:
                        if es.getplayerteam(ev["userid"]) == 3:
                                r = 0
                                b = 255
                        else:
                                r = 255
                                b = 0
                        x,y,z = es.getplayerlocation(ev["userid"])
                        effectlib.drawLine((ev["x"],ev["y"],ev["z"]),(x,y,z + 20),halo=es.ServerVar("superdice_lasermodel"),model=es.ServerVar("superdice_lasermodel"),seconds=0.5,width=10,endwidth=10,red=r,green=50,blue=b)
                        effectlib.drawLine((ev["x"],ev["y"],ev["z"]),(x,y,z + 20),halo=es.ServerVar("superdice_lasermodel"),model=es.ServerVar("superdice_lasermodel"),seconds=0.5,width=10,endwidth=10,red=r,green=50,blue=b)

events = "addons/eventscripts/superdice/superdice.res"
config = "../cfg/eventscripts/superdice/superdice.cfg"
tick = 0
blocks = {}
players = {}
ccommands = ["rtd","!rtd","superdice","!superdice","rollthedice","!rollthedice"]
hcommands = ["rtdhelp","!rtdhelp","superdicehelp","!superdicehelp"]
playervars = ["inf","lust","roll","berserker","feeble","highjump","longjump","sunglasses","deadman","heavy","beacon","lasers","drug","tunnel","fnade","istab","fport","pgas","gcase","wguns","barrier"]
blist = ["c4","nvg","suit","knife","elite","flashbang","hegrenade","smokegrenade"]
variables = ["spytmodel","spyctmodel","barriermod","fnadegive","fnadegiveback","fportgive","fportgiveback","pgasgive","pgasgiveback","pgastime","istabtime","fnadetime","wcslevel","gglevel","rollfailsound","lasermodel","rollinfo","drugoverlay","beaconmodel","gamblelose","gamblechance","gamblewin","berserkertime","tickrate","menusound","rolltime","rollsound","rollchanceshout","infmod","heavymax","heavymin","rollchance","shout","healthmod","superhealthmod","cursemod","tmp","tmp1","tmp2","timemod","lustmod","diceymin","diceymax","armormod","berserkerspeed","berserkerclip","berserkerhealth","illusionalpha","feeblemod","badeyesmin","badeyesmax","badeyesdur","weightsmod","superdiceblock","superdicehelpblock","aeromod","acromod","tmp3"]
for var in variables: es.ServerVar("superdice_%s"%var).set(0)
es.dbgmsg(0,"[Super Dice] Loading blocks....")
es.load("superdice/superdiceblocks")
es.dbgmsg(0,"[Super Dice] Creating superdice_* commands....")
cmdlib.registerServerCommand("superdice_addblock",AddBlock,"Adds a block to Super Dice's blocks list. | superdice_addblock <blockname> <rollname> <rolldesc>",skipcheck=True)
cmdlib.registerServerCommand("superdice_removeblock",RemoveBlock,"Removes a block from Super Dice's blocks list. | superdice_removeblock <block name>",skipcheck=True)
cmdlib.registerServerCommand("superdice_clearblocks",ClearBlocks,"Clears the blocks from Super Dice's blocks list. | superdice_clearblocks",skipcheck=True)
cmdlib.registerServerCommand("superdice_reloadblocks",ReloadBlocks,"Reloads Super Dice's superdiceblocks script. | superdice_reloadblocks",skipcheck=True)
cmdlib.registerServerCommand("superdice_reloadconfig",ReloadConfig,"Reloads Super Dice's config. | superdice_reloadconfig",skipcheck=True)
cmdlib.registerServerCommand("superdice_createhelp",CreateHelp,"Creates the help popup. | superdice_createhelp",skipcheck=True)
cmdlib.registerServerCommand("superdice_playerdata",PlayerData,"Lets you set/get/check Super Dice's playerdata. | superdice_playerdata <set/get/check> <userid> <dataname> <setting/return var/return var>",skipcheck=True)
cmdlib.registerServerCommand("superdice_randomblind",RandomBlind,"Lets start a random delayed blinding on a player. | superdice_randomblind <userid> <min time> <max time> <blind time>",skipcheck=True)
cmdlib.registerServerCommand("superdice_respawn",Respawn,"Respawns a player. | superdice_respawn <userid>",skipcheck=True)
cmdlib.registerServerCommand("superdice_damage",Damage,"Damages a player. | superdice_damage <attacker> <victim> <damage>",skipcheck=True)
cmdlib.registerServerCommand("superdice_teleport",Teleport,"Teleports a player. | superdice_teleport <useird> <'x,y,z'>",skipcheck=True)
cmdlib.registerServerCommand("superdice_renderfx",RenderFX,"Sets a player's renderfx. | superdice_renderfx <useird> <fx>",skipcheck=True)
if GGon: cmdlib.registerServerCommand("superdice_gungame_levelup",GGLevelUp,"Levels up a player. | superdice_gungame_levelup <userid> <levels>",skipcheck=True)
es.dbgmsg(0,"[Super Dice] Executing config....")
es.mexec(config)
es.dbgmsg(0,"[Super Dice] Declaring events....")
es.loadevents("declare",events)
es.loadevents(events)
es.dbgmsg(0,"[Super Dice] Loading other stuff....")
es.addons.registerTickListener(tickcallback)
es.addons.registerSayFilter(chatcommands)
roundchange(0)
gamethread.delayed(0.1,downloads,())
es.doblock("corelib/noisy_on")
es.dbgmsg(0,"[Super Dice] Declaring public variable....") 
es.ServerVar("superdice_version").set(info["version"])
es.ServerVar("superdice_version").makepublic()
es.dbgmsg(0,"[Super Dice] Loaded successfully!")

def unload():
        es.doblock("corelib/noisy_off")
        es.dbgmsg(0,"[Super Dice] Unloading blocks....")
        es.unload("superdice/superdiceblocks")
        es.dbgmsg(0,"[Super Dice] Deleting commands....")
	cmdlib.unregisterServerCommand("superdice_addblock")
	cmdlib.unregisterServerCommand("superdice_removeblock")
	cmdlib.unregisterServerCommand("superdice_clearblocks")
	cmdlib.unregisterServerCommand("superdice_reloadblocks")
	cmdlib.unregisterServerCommand("superdice_reloadconfig")
	cmdlib.unregisterServerCommand("superdice_createhelp")
	cmdlib.unregisterServerCommand("superdice_playerdata")
	cmdlib.unregisterServerCommand("superdice_randomblind")
	cmdlib.unregisterServerCommand("superdice_respawn")
	cmdlib.unregisterServerCommand("superdice_damage")
	cmdlib.unregisterServerCommand("superdice_teleport")
	cmdlib.unregisterServerCommand("superdice_renderfx")
	if GGon: cmdlib.unregisterServerCommand("superdice_gungame_levelup")
	es.dbgmsg(0,"[Super Dice] Unloading other stuff....")
	es.addons.unregisterTickListener(tickcallback)
	es.addons.unregisterSayFilter(chatcommands)
	es.dbgmsg(0,"[Super Dice] Unloaded successfully!")
